﻿//DESCRIPTION:Update any TOCs in the active document

// Modified 2021-01-12
// Keith Gilbert, Gilbert Consulting
// www.gilbertconsulting.com

Pre();

function Pre () {
	if (!app.documents.length) { 
		alert("No InDesign documents are open. Please open a document and try again.");
		return;
	}  
	// Main();
	app.doScript(Main, undefined, undefined, UndoModes.ENTIRE_SCRIPT,"Run Script");
}

function Main () {
    var myDoc = app.activeDocument;
    // Remember the current view
    var myPage = app.activeWindow.activePage;
    var myObjectsArray = myDoc.allPageItems; // allPageItems returns an array of all objects in the document, even those in groups
    var myNumObjects = myObjectsArray.length;
    var myNumTOC = 0;
    for (var i=myNumObjects-1; i>=0; i--) {
        var myObject = myObjectsArray[i];
        if (myObject.constructor.name == "TextFrame") {
            if (myObject.parentStory.storyType == StoryTypes.TOC_STORY) {
                myObject.select();
                // Update the TOC
                app.scriptMenuActions.itemByID(71442).invoke();
                myNumTOC++;
            }
        }
    }
    // Return the view to what it was
    app.activeWindow.activePage = myPage;
    if (myNumTOC == 1) {
        alert("1 TOC updated.");
    }
    else {
        if (myNumTOC > 1) {
            alert(myNumTOC+" TOCs updated.")
        }
        else {
            alert ("No TOCs found in this document.");
        }
    }
}